

BGTCLI(1)		(Nonessential Utilities)		BGTCLI(1)



NAME
	bgtcli - A raw TCP/IP protocol client

SYNOPSIS
	bgtcli [-r|-s] [-t] [-a] system [port]

DESCRIPTION

	This program is a raw connector to a remote system.  It connects
to the system specified on the command line, and to the port specified.
If no port is specified, it connects to the default telnet port, port 23.
'bgtcli' does no protocol handling, and sends everything typed directly
to the remote connection.  It will normally read a line at a time,
in cooked mode, unless the '-r' option is specified.  If the '-r' option
is specified, each character typed will be sent immediately to the 
remote system, and any echoing will be done by the remote system.
When you connect to a telnet port, some unprintable characters may be
displayed on your screen because of the telnet negotiations.  This can
be eliminated by using the '-a' option of bgtcli.  The '-a' option sets
'bgtcli's ascii mode.  In ascii mode, bgtcli will only send printable 
ascii characters to your screen, plus the newline, carriage return, tab, 
and the escape character for screen handling.  The bell character will 
also be sent.  All other characters are flushed from the stream.

	There is one escape implemented.  If the Control key and the 'x'
key are pressed simultaneously, 'bgtcli' will read the next character and
see if it matches a builtin command.  At this time, only two builtins
are implemented in bgtcli:
	Character	Function

	    x		Terminate the connection immediately.  
	    z		For systems that support it, this places
			the bgtcli session in the background.
	    s		Disconnects 'bgtcli' from the terminal,
			allowing you to log in at a later time
			and resume your session with the 'connect'
			program.  Only one session may be disconnected
			at a time.  This feature has only been
			tested on Sun/OS 4.x UNIX.

If bgtcli is not in raw/remote-echo mode, you must press return before 
the builtin will be recognized.


OPTIONS
	
	-r	Sets raw/remote-echo mode

	-a	Sets ascii mode

	-s	Sets null-terminated string mode.  Used to emulate 'rexec'.

	-t	Forces telnet negotiation.  This is useful if you are
		connecting to a special port (besides 23) that requires
		telnet negotiations, but is not usually necessary.
		bgtcli automatically uses telnet negotiation when it
		is invoked without a port argument, or is connecting
		to port 23.

	-x	Sets telnet debug mode, showing option processing.


BUGS
	bgtcli sometimes has problems logging into a telnet port because it
	uses very rudimentary telnet negotiation.  What will sometimes 
	happen is the connection will simply block, requiring the use of 
	Ctrl-X to disconnect.  
	If you disconnect the bgtcli session and then reconnect under a
	different terminal, when you then use the Ctrl-X-z suspend
	sequence, the connect session is suspended, but bgtcli in the
	background is still reading and writing to the terminal, not
	allowing the shell any access to the terminal.


SERVICES:

Service: rexec				Port: 512	<'-s' bgtcli option>

Usage: (Using the '-s' option)
       ENTER 0
       ENTER <user>
       ENTER <password>		(The password will be echoed!>
       ENTER <command>
       the remote system execute the command as though "user" had logged in.


Service: finger				Port: 79  	<local echo>

Usage:	ENTER name
	returns info about name.


Service: sendmail			Port: 25	<local echo>

Usage:	ENTER MAIL FROM: <name>
	ENTER RCPT TO: <user>
	ENTER DATA <message terminated by a dot on a newline>
	ENTER QUIT


Service: telnet				Port: 23	<remote echo>

Usage: TELNET SESSION
       Sometimes remote echo is required, and sometimes the connection
won't be made quite right due to extremely basic telnet protocol
handling.  Also because of this, a couple of wierd characters appear
on the screen on connection.  These can be ignored.


Service: echo				Port: 7		<local echo>

Usage: ENTER <anything>
       echoes anything.
