/* getipaddr <address>  -A program that takes a command line argument and
			 returns the dotted-decimal internet address.

   For AT&T System V.3 UNIX */

#include 	<sys/types.h>
#include	<stdio.h>
#include 	<sys/in.h>
#include 	<netdb.h>


/* library function declarations */

unsigned long inet_addr();
char	*inet_ntoa();
char 	*host_err_str();

#define INADDR_NONE	0xffffffff

main(argc, argv)
int argc;
char *argv[];
{
	struct sockaddr_in	serv_addr;
	struct hostent		*hp;

	if ( (serv_addr.sin_addr.s_addr=inet_addr(argv[1])) == INADDR_NONE )
	{  /* It's not a dotted-decimal address */

		if ( (hp=gethostbyname(argv[1])) == NULL )
		{
			fprintf(stderr, "host name error: %s %s\r\n", argv[1],
								host_err_str());
			exit(1);
		}
		else 
			bcopy(hp->h_addr, (char *)&serv_addr.sin_addr, hp->h_length);
	}

	printf("%s\n", inet_ntoa(serv_addr.sin_addr));

	exit(0);
}


/* The host error function */

int	h_errno;		/* host error number */
int	h_nerr;			/* # of error message strings */
char	*h_errlist[];		/* the error message table */

char *host_err_str()
{
	static char	msgstr[200];

	if (h_errno != 0) {
		if (h_errno > 0 && h_errno < h_nerr)
			sprintf(msgstr, "(%s)", h_errlist[h_errno]);
		else
			sprintf(msgstr, "(h_errno = %d)", h_errno);
	} else {
		msgstr[0] = '\0';
	}

	return(msgstr);
}
